-- main.applescript
-- PlayPart

--  Created by Stefan Huy on 6/21/05.
--  Copyright 2005 __MyCompanyName__. All rights reserved.

on run {input, parameters}
	-- die Parameter-Namen aus den Bindings mssen in "Pipe"-Zeichen eingeschlossen werden
	set waitWord to |waitWord| of parameters
	set doLoop to |doLoop| of parameters
	set startTime to |startTime| of parameters
	set endTime to |endTime| of parameters
	set preExit to |preExit| of parameters
	-- die einzigen Checks, die wir durchfhren
	if endTime < startTime then set endTime to startTime
	if endTime - startTime < preExit then set preExit to 0
	-- ahben wir ein "Waitword"?
	if waitWord  "" then
		do shell script "open /System/Library/Frameworks/Carbon.framework/Frameworks/SpeechRecognition.framework/Resources/SpeechRecognitionServer.app"
		try
			tell application "SpeechRecognitionServer"
				listen for "Mana>Mana"
			end tell
		end try
	end if
	tell application "QuickTime Player"
		tell movie 1
			set timeScale to time scale
			set startFrame to startTime * timeScale / 1000
			set endFrame to endTime * timeScale / 1000
			set selection start to startFrame
			set selection end to endFrame
			set current time to selection start
			set play selection only to true
			set looping to doLoop
			play
			-- busy wait mit preExit, falls kein Loop
			if not doLoop then
				set effectiveEnd to endFrame - preExit * timeScale / 1000
				repeat
					if current time  effectiveEnd then exit repeat
				end repeat
			end if
		end tell
	end tell
	return input
end run